package com.clx.performance.service.impl.collect;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.clx.performance.dao.collect.CollectTrafficCongestionDao;
import com.clx.performance.enums.PerformanceResultEnum;
import com.clx.performance.model.collect.CollectTrafficCongestion;
import com.clx.performance.param.app.collect.CollectTrafficCongestionSaveParam;
import com.clx.performance.param.app.collect.PageCollectTraficCongestionParam;
import com.clx.performance.service.collect.CollectTrafficCongestionService;
import com.clx.performance.struct.collect.CollectTrafficCongestionStruct;
import com.clx.performance.vo.app.collect.CollectTrafficCongestionVO;
import com.msl.user.data.UserSessionData;
import com.msl.user.utils.TokenUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

@Slf4j
@Service
public class CollectTrafficCongestionServiceImpl implements CollectTrafficCongestionService {

    @Autowired
    private CollectTrafficCongestionDao collectTrafficCongestionDao;

    @Autowired
    private CollectTrafficCongestionStruct collectTrafficCongestionStruct;


    @Override
    public void saveTrafficReport(CollectTrafficCongestionSaveParam param) {
        UserSessionData loginUserInfo = TokenUtil.getLoginUserInfo();
        Long userNo = loginUserInfo.getUserNo();

        CollectTrafficCongestion collectTrafficCongestion = new CollectTrafficCongestion();
        collectTrafficCongestion.setUserNo(userNo);
        collectTrafficCongestion.setName(loginUserInfo.getUserName());
        collectTrafficCongestion.setMobile(loginUserInfo.getUserMobile());

        collectTrafficCongestion.setTruckNo("");

        collectTrafficCongestion.setLongitude(param.getLongitude());
        collectTrafficCongestion.setLatitude(param.getLatitude());
        collectTrafficCongestion.setAddress(param.getAddress());

        collectTrafficCongestion.setJamTime(param.getJamTime());
        collectTrafficCongestion.setJamImage(JSON.toJSONString(param.getJamImageList()));
        collectTrafficCongestion.setReportTime(LocalDateTime.now());
        collectTrafficCongestionDao.saveEntity(collectTrafficCongestion);
    }

    @Override
    public CollectTrafficCongestionVO getReportInfo(Integer id) {
        return collectTrafficCongestionDao.getEntityByKey(id).map(collectTrafficCongestionStruct::convert).orElseThrow(PerformanceResultEnum.DATA_NOT_FIND);

    }

    @Override
    public IPage<CollectTrafficCongestionVO> pageTrafficReport(PageCollectTraficCongestionParam param) {
        UserSessionData loginUserInfo = TokenUtil.getLoginUserInfo();
        Long userNo = loginUserInfo.getUserNo();

        param.setUserNo(userNo);
        return collectTrafficCongestionDao.pageTraffic(param);
    }
}
