package com.clx.performance.service.impl.collect;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.clx.performance.dao.collect.CollectTruckLocationDao;
import com.clx.performance.enums.PerformanceResultEnum;
import com.clx.performance.model.collect.CollectTruckLocation;
import com.clx.performance.model.collect.CollectTruckRefuel;
import com.clx.performance.param.app.collect.CollectTruckLocationSaveParam;
import com.clx.performance.param.app.collect.PageCollectTruckLocationParam;
import com.clx.performance.service.collect.CollectTruckLocationService;
import com.clx.performance.struct.collect.CollectTruckLocationStruct;
import com.clx.performance.vo.app.collect.CollectTruckLocationVO;
import com.msl.user.data.UserSessionData;
import com.msl.user.utils.TokenUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

@Slf4j
@Service
public class CollectTruckLocationServiceImpl implements CollectTruckLocationService {

    @Autowired
    private CollectTruckLocationDao collectTruckLocationDao;

    @Autowired
    private CollectTruckLocationStruct collectTruckLocationStruct;


    @Override
    public void saveLocationReport(CollectTruckLocationSaveParam param) {
        UserSessionData loginUserInfo = TokenUtil.getLoginUserInfo();
        Long userNo = loginUserInfo.getUserNo();

        CollectTruckLocation collectTruckLocation = new CollectTruckLocation();
        collectTruckLocation.setUserNo(userNo);
        collectTruckLocation.setName(loginUserInfo.getUserName());
        collectTruckLocation.setMobile(loginUserInfo.getUserMobile());

        collectTruckLocation.setTruckNo(param.getTruckNo());
        collectTruckLocation.setTruckOrderStatus(param.getTruckOrderStatus());
        collectTruckLocation.setLongitude(param.getLongitude());
        collectTruckLocation.setLatitude(param.getLatitude());
        collectTruckLocation.setAddress(param.getAddress());
        collectTruckLocation.setReportTime(LocalDateTime.now());

        collectTruckLocationDao.saveEntity(collectTruckLocation);
    }

    @Override
    public CollectTruckLocationVO getReportInfo(Integer id) {
        return collectTruckLocationDao.getEntityByKey(id).map(collectTruckLocationStruct::convert).orElseThrow(PerformanceResultEnum.DATA_NOT_FIND);

    }

    @Override
    public IPage<CollectTruckLocationVO> pageLocationReport(PageCollectTruckLocationParam param) {
        UserSessionData loginUserInfo = TokenUtil.getLoginUserInfo();
        Long userNo = loginUserInfo.getUserNo();

        param.setUserNo(userNo);
        return collectTruckLocationDao.pageLocation(param);
    }
}
